Index: TWiki/UI/Upload.pm
===================================================================
--- TWiki/UI/Upload.pm	(revision 13172)
+++ TWiki/UI/Upload.pm	(working copy)
@@ -39,7 +39,7 @@
 
 =pod
 
----++ StaticMethod attach( $session )
+---++ StaticMethod attach()
 
 =upload= command handler.
 This method is designed to be
@@ -51,16 +51,14 @@
 =cut
 
 sub attach {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-
     my $fileName = $query->param( 'filename' ) || '';
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'attach' );
+    TWiki::UI::checkWebExists( $webName, $topic, 'attach' );
 
     my $tmpl = '';
     my $text = '';
@@ -69,15 +67,13 @@
     my $fileUser = '';
     my $isHideChecked = '';
 
-    TWiki::UI::checkMirror( $session, $webName, $topic );
-
-    TWiki::UI::checkAccess( $session, $webName, $topic,
-                            'CHANGE', $session->{user} );
-    TWiki::UI::checkTopicExists( $session, $webName, $topic,
+    TWiki::UI::checkAccess( $webName, $topic,
+                            'CHANGE', $TWiki::SESSION->{user} );
+    TWiki::UI::checkTopicExists( $webName, $topic,
                                  'upload files to' );
 
     ( $meta, $text ) =
-      $session->{store}->readTopic( $session->{user}, $webName, $topic, undef );
+      $TWiki::STORE->readTopic( $TWiki::SESSION->{user}, $webName, $topic, undef );
     my $args = $meta->get( 'FILEATTACHMENT', $fileName );
     $args = {
              name => $fileName,
@@ -95,38 +91,38 @@
     # Attach is a read function, only has potential for a change
     if( $TWiki::cfg{Log}{attach} ) {
         # write log entry
-        $session->writeLog( 'attach', $webName.'.'.$topic, $fileName );
+        $TWiki::SESSION->writeLog( 'attach', $webName.'.'.$topic, $fileName );
     }
 
     my $fileWikiUser = '';
     if( $fileName ) {
-        $tmpl = $session->{templates}->readTemplate( 'attachagain', $skin );
-        my $u = $session->{users}->findUser( $args->{user} );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'attachagain', $skin );
+        my $u = $TWiki::USERS->findUser( $args->{user} );
         $fileWikiUser = $u->webDotWikiName() if $u;
     } else {
-        $tmpl = $session->{templates}->readTemplate( 'attachnew', $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'attachnew', $skin );
     }
     if ( $fileName ) {
         # must come after templates have been read
-        $atext .= $session->{attach}->formatVersions( $webName, $topic, %$args );
+        $atext .= $TWiki::ATTACH->formatVersions( $webName, $topic, %$args );
     }
     $tmpl =~ s/%ATTACHTABLE%/$atext/go;
     $tmpl =~ s/%FILEUSER%/$fileWikiUser/go;
-    $session->enterContext( 'can_render_meta', $meta );
-    $tmpl = $session->handleCommonTags( $tmpl, $webName, $topic );
-    $tmpl = $session->{renderer}->getRenderedVersion( $tmpl, $webName, $topic );
+    $TWiki::SESSION->enterContext( 'can_render_meta', $meta );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $webName, $topic );
+    $tmpl = $TWiki::RENDER->getRenderedVersion( $tmpl, $webName, $topic );
     $tmpl =~ s/%HIDEFILE%/$isHideChecked/go;
     $tmpl =~ s/%FILENAME%/$fileName/go;
     $tmpl =~ s/%FILEPATH%/$args->{path}/go;
     $args->{comment} = TWiki::entityEncode( $args->{comment} );
     $tmpl =~ s/%FILECOMMENT%/$args->{comment}/go;
 
-    $session->writeCompletePage( $tmpl );
+    $TWiki::SESSION->writeCompletePage( $tmpl );
 }
 
 =pod
 
----++ StaticMethod upload( $session )
+---++ StaticMethod upload( $TWiki::SESSION )
 
 =upload= command handler.
 This method is designed to be
@@ -149,13 +145,11 @@
 =cut
 
 sub upload {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $user = $TWiki::SESSION->{user};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-    my $user = $session->{user};
-
     my $hideFile = $query->param( 'hidefile' ) || '';
     my $fileComment = $query->param( 'filecomment' ) || '';
     my $createLink = $query->param( 'createlink' ) || '';
@@ -173,10 +167,9 @@
     $fileName =~ s/\s*$//o;
     $filePath =~ s/\s*$//o;
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'attach files to' );
-    TWiki::UI::checkTopicExists( $session, $webName, $topic, 'attach files to' );
-    TWiki::UI::checkMirror( $session, $webName, $topic );
-    TWiki::UI::checkAccess( $session, $webName, $topic,
+    TWiki::UI::checkWebExists( $webName, $topic, 'attach files to' );
+    TWiki::UI::checkTopicExists( $webName, $topic, 'attach files to' );
+    TWiki::UI::checkAccess( $webName, $topic,
                             'CHANGE', $user );
 
     my ( $fileSize, $fileDate, $tmpFileName );
@@ -205,7 +198,7 @@
                                         params => ($filePath || '""') );
         }
 
-        my $maxSize = $session->{prefs}->getPreferencesValue( 'ATTACHFILESIZELIMIT' );
+        my $maxSize = $TWiki::PREFS->getPreferencesValue( 'ATTACHFILESIZELIMIT' );
         $maxSize = 0 unless ( $maxSize =~ /([0-9]+)/o );
 
         if( $maxSize && $fileSize > $maxSize * 1024 ) {
@@ -218,7 +211,7 @@
     }
 
     try {
-        $session->{store}->saveAttachment(
+        $TWiki::STORE->saveAttachment(
             $webName, $topic, $fileName, $user,
             { dontlog => !$TWiki::cfg{Log}{upload},
               comment => $fileComment,
@@ -240,8 +233,8 @@
     close( $stream ) if $stream;
 
     if( $fileName eq $origName ) {
-	    my $redirecturl = _getRedirectUrl( $session ) || $session->getScriptUrl( 1, 'view', $webName, $topic );
-        $session->redirect( $redirecturl );
+	    my $redirecturl = _getRedirectUrl() || $TWiki::SESSION->getScriptUrl( 1, 'view', $webName, $topic );
+        $TWiki::SESSION->redirect( $redirecturl );
     } else {
         throw TWiki::OopsException( 'attention',
                                     def => 'upload_name_changed',
@@ -267,9 +260,7 @@
 =cut
 
 sub _getRedirectUrl {
-    my $session = shift;
-
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $redirecturl = $query->param( 'redirectto' );
     return '' unless $redirecturl;
     if( $redirecturl =~ /^$TWiki::regex{linkProtocolPattern}\:\/\//o ) {
@@ -281,8 +272,8 @@
         }
     }
     # assuming 'web.topic' or 'topic'
-    my ( $w, $t ) = $session->normalizeWebTopicName( $session->{webName}, $redirecturl );
-    $redirecturl = $session->getScriptUrl( 1, 'view', $w, $t );
+    my ( $w, $t ) = $TWiki::SESSION->normalizeWebTopicName( $TWiki::SESSION->{webName}, $redirecturl );
+    $redirecturl = $TWiki::SESSION->getScriptUrl( 1, 'view', $w, $t );
 }
 
 1;
Index: TWiki/UI/Edit.pm
===================================================================
--- TWiki/UI/Edit.pm	(revision 13172)
+++ TWiki/UI/Edit.pm	(working copy)
@@ -46,7 +46,7 @@
 
 =pod
 
----++ StaticMethod edit( $session )
+---++ StaticMethod edit( )
 
 Edit command handler.
 This method is designed to be
@@ -67,19 +67,18 @@
 =cut
 
 sub edit {
-    my $session = shift;
-    my ( $text, $tmpl ) = init_edit( $session, 'edit' );
-    finalize_edit ( $session, $text, $tmpl );
+    my ( $text, $tmpl ) = _init_edit( 'edit' );
+    _finalize_edit( $text, $tmpl );
 }
 
 
-sub init_edit {
-    my ( $session, $templateName )  = @_;
+sub _init_edit {
+    my ( $templateName )  = @_;
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-    my $user = $session->{user};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $user = $TWiki::SESSION->{user};
 
     # empty means edit both form and text, "form" means edit form only,
     # "text" means edit text only
@@ -94,13 +93,12 @@
     # apptype is undocumented legacy
     my $cgiAppType = $query->param( 'contenttype' ) ||
       $query->param( 'apptype' ) || 'text/html';
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
     my $theParent = $query->param( 'topicparent' ) || '';
     my $ptext = $query->param( 'text' );
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'edit' );
-    TWiki::UI::checkMirror( $session, $webName, $topic );
+    TWiki::UI::checkWebExists( $webName, $topic, 'edit' );
 
     my $tmpl = '';
     my $text = '';
@@ -109,8 +107,8 @@
     my $topicExists  = $store->topicExists( $webName, $topic );
 
     # If you want to edit, you have to be able to view and change.
-    TWiki::UI::checkAccess( $session, $webName, $topic, 'VIEW', $user );
-    TWiki::UI::checkAccess( $session, $webName, $topic, 'CHANGE', $user );
+    TWiki::UI::checkAccess( $webName, $topic, 'VIEW', $user );
+    TWiki::UI::checkAccess( $webName, $topic, 'CHANGE', $user );
 
     # Check lease, unless we have been instructed to ignore it
     # or if we are using the 10X's or AUTOINC topic name for
@@ -135,7 +133,7 @@
                             $TWiki::cfg{LeaseLengthLessForceful} ) {
                         $def = 'lease_old';
                         $past = TWiki::Time::formatDelta(
-                            $t - $lease->{expires}, $session->{i18n} );
+                            $t - $lease->{expires}, $TWiki::I18N );
                         $future = '';
                     }
                 }
@@ -143,9 +141,9 @@
                     # The lease is active
                     $def = 'lease_active';
                     $past = TWiki::Time::formatDelta(
-                        $t - $lease->{taken}, $session->{i18n} );
+                        $t - $lease->{taken}, $I18N );
                     $future = TWiki::Time::formatDelta(
-                        $lease->{expires} - $t, $session->{i18n} );
+                        $lease->{expires} - $t, $I18N );
                 }
                 if( $def ) {
                     # use a 'keep' redirect to ensure we pass parameter
@@ -188,7 +186,7 @@
           $store->readTopic( undef, $webName, $topic, undef );
     }
 
-    if( $saveCmd && ! $session->{user}->isAdmin()) {
+    if( $saveCmd && ! $TWiki::SESSION->{user}->isAdmin()) {
         throw TWiki::OopsException( 'accessdenied', def=>'only_group',
                                     web => $webName, topic => $topic,
                                     params => $TWiki::cfg{UsersWebName}.
@@ -198,13 +196,13 @@
 
     # Get edit template, standard or a different skin
     my $template = $query->param( 'template' ) ||
-	$session->{prefs}->getPreferencesValue('EDIT_TEMPLATE') ||
+	$TWiki::PREFS->getPreferencesValue('EDIT_TEMPLATE') ||
         $templateName;
     $tmpl =
-      $session->{templates}->readTemplate( $template.$editaction, $skin );
+      $TWiki::TEMPLATES->readTemplate( $template.$editaction, $skin );
 
     if( !$tmpl && $template ne $templateName ) {
-        $tmpl = $session->{templates}->readTemplate( $templateName, $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( $templateName, $skin );
     }
 
     if( !$tmpl ) {
@@ -220,7 +218,7 @@
     unless( $topicExists ) {
         if( $templateTopic ) {
             ( $templateWeb, $templateTopic ) =
-              $session->normalizeWebTopicName( $templateWeb, $templateTopic );
+              $TWiki::SESSION->normalizeWebTopicName( $templateWeb, $templateTopic );
 
             unless( $store->topicExists( $templateWeb, $templateTopic )) {
                 throw TWiki::OopsException( 'accessdenied',
@@ -231,11 +229,11 @@
             }
 
             ( $meta, $text ) =
-              $store->readTopic( $session->{user}, $templateWeb,
+              $store->readTopic( $TWiki::SESSION->{user}, $templateWeb,
                                         $templateTopic, undef );
             $templateTopic = $templateWeb.'.'.$templateTopic;
         } else {
-            ( $meta, $text ) = TWiki::UI::readTemplateTopic( $session, 'WebTopicEditTemplate' );
+            ( $meta, $text ) = TWiki::UI::readTemplateTopic('WebTopicEditTemplate' );
         }
 
         $extra = "(not exist)";
@@ -246,7 +244,7 @@
             $formTemplate = $form->{name} if $form;
         }
 
-        $text = $session->expandVariablesOnTopicCreation( $text, $user );
+        $text = $TWiki::SESSION->expandVariablesOnTopicCreation( $text, $user );
         $tmpl =~ s/%NEWTOPIC%/1/;
     } else {
         $tmpl =~ s/%NEWTOPIC%//;
@@ -272,7 +270,7 @@
     } elsif( $theParent ) {
         my $parentWeb;
         ($parentWeb, $theParent) =
-          $session->normalizeWebTopicName( $webName, $theParent );
+          $TWiki::SESSION->normalizeWebTopicName( $webName, $theParent );
         if( $parentWeb ne $webName ) {
             $theParent = $parentWeb.'.'.$theParent;
         }
@@ -299,40 +297,40 @@
     }
 
     if( $saveCmd ) {
-        $text = $store->readTopicRaw( $session->{user}, $webName,
+        $text = $store->readTopicRaw( $TWiki::SESSION->{user}, $webName,
                                                  $topic, undef );
     }
 
-    $session->{plugins}->beforeEditHandler(
+    $TWiki::PLUGINS->beforeEditHandler(
         $text, $topic, $webName, $meta ) unless( $saveCmd );
 
     if( $TWiki::cfg{Log}{edit} ) {
         # write log entry
-        $session->writeLog( 'edit', $webName.'.'.$topic, $extra );
+        $TWiki::SESSION->writeLog( 'edit', $webName.'.'.$topic, $extra );
     }
 
     $tmpl =~ s/\(edit\)/\(edit cmd=$saveCmd\)/go if $saveCmd;
 
     $tmpl =~ s/%CMD%/$saveCmd/go;
-    $session->enterContext( 'can_render_meta', $meta );
+    $TWiki::SESSION->enterContext( 'can_render_meta', $meta );
 
-    $tmpl = $session->handleCommonTags( $tmpl, $webName, $topic, $meta );
-    $tmpl = $session->{renderer}->getRenderedVersion( $tmpl, $webName, $topic );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $webName, $topic, $meta );
+    $tmpl = $TWiki::RENDER->getRenderedVersion( $tmpl, $webName, $topic );
     # Don't want to render form fields, so this after getRenderedVersion
     my $formMeta = $meta->get( 'FORM' );
     my $form = '';
     my $formText = '';
     $form = $formMeta->{name} if( $formMeta );
     if( $form && !$saveCmd ) {
-        my $formDef = new TWiki::Form( $session, $templateWeb, $form );
+        my $formDef = new TWiki::Form( $TWiki::SESSION, $templateWeb, $form );
         unless( $formDef ) {
             throw TWiki::OopsException( 'attention',
                                         def => 'no_form_def',
-                                        web => $session->{webName},
-                                        topic => $session->{topicName},
+                                        web => $TWiki::SESSION->{webName},
+                                        topic => $TWiki::SESSION->{topicName},
                                         params => [ $templateWeb, $form ] );
         }
-        $formDef->getFieldValuesFromQuery( $session->{cgiQuery}, $meta );
+        $formDef->getFieldValuesFromQuery( $TWiki::SESSION->{cgiQuery}, $meta );
         # And render them for editing
         # SMELL: these are both side-effecting functions, that will set
         # default values for fields if they are not set in the meta.
@@ -342,9 +340,9 @@
         } else {
             $formText = $formDef->renderForEdit( $webName, $topic, $meta );
         }
-    } elsif( !$saveCmd && $session->{prefs}->getWebPreferencesValue( 'WEBFORMS', $webName )) {
-        $formText = $session->{templates}->readTemplate( "addform", $skin );
-        $formText = $session->handleCommonTags(
+    } elsif( !$saveCmd && $TWiki::PREFS->getWebPreferencesValue( 'WEBFORMS', $webName )) {
+        $formText = $TWiki::TEMPLATES->readTemplate( "addform", $skin );
+        $formText = $TWiki::SESSION->handleCommonTags(
             $formText, $webName, $topic, $meta );
     }
     $tmpl =~ s/%FORMFIELDS%/$formText/g;
@@ -354,14 +352,14 @@
     return ( $text, $tmpl );
 }
 
-sub finalize_edit {
+sub _finalize_edit {
 
-    my ( $session, $text, $tmpl ) = @_;
+    my ( $text, $tmpl ) = @_;
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-    my $user = $session->{user};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $user = $TWiki::SESSION->{user};
     # apptype is undocumented legacy
     my $cgiAppType = $query->param( 'contenttype' ) ||
       $query->param( 'apptype' ) || 'text/html';
@@ -371,9 +369,9 @@
     $text = TWiki::entityEncode( $text );
     $tmpl =~ s/%TEXT%/$text/g;
 
-    $session->{store}->setLease( $webName, $topic, $user, $TWiki::cfg{LeaseLength} );
+    $TWiki::STORE->setLease( $webName, $topic, $user, $TWiki::cfg{LeaseLength} );
 
-    $session->writeCompletePage( $tmpl, 'edit', $cgiAppType );
+    $TWiki::SESSION->writeCompletePage( $tmpl, 'edit', $cgiAppType );
 }
 
 1;
Index: TWiki/UI/Search.pm
===================================================================
--- TWiki/UI/Search.pm	(revision 13172)
+++ TWiki/UI/Search.pm	(working copy)
@@ -33,7 +33,7 @@
 
 =pod
 
----++ StaticMethod search( $session )
+---++ StaticMethod search( )
 
 Perform a search as dictated by CGI parameters:
 
@@ -67,14 +67,12 @@
 =cut
 
 sub search {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
+    TWiki::UI::checkWebExists( $webName, $topic, 'search' );
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'search' );
-
     # The CGI.pm docs claim that it returns all of the values in a
     # multiple select if called in a list context, but that may not
     # work (didn't on the dev box -- perl 5.004_4 and CGI.pm 2.36 on
@@ -105,10 +103,10 @@
     $attrWeb =~ tr/+/ /;       # pluses become spaces
     $attrWeb =~ s/%([0-9a-fA-F]{2})/pack('c',hex($1))/ge;  # %20 becomes space
 
-#    $session->writePageHeader();
+#    $TWiki::SESSION->writePageHeader();
 
     # SMELL: what's all the 'scalar' crud, below?
-    my $text = $session->{search}->searchWeb(
+    my $text = $TWiki::SEARCH->searchWeb(
 #        _callback       => \&_contentCallback,	#FIXME - can't process format=| $topic | line by line...
         _callback       => undef,
         _cbdata         => undef,
@@ -120,7 +118,7 @@
         'scope'         => scalar $query->param( 'scope' ),
         'order'         => scalar $query->param( 'order' ),
         'type'          => scalar $query->param( 'type' ) ||
-          $session->{prefs}->getPreferencesValue( 'SEARCHDEFAULTTTYPE' ),
+          $TWiki::PREFS->getPreferencesValue( 'SEARCHDEFAULTTTYPE' ),
         'regex'         => scalar $query->param( 'regex' ),
         'limit'         => scalar $query->param( 'limit' ),
         'reverse'       => scalar $query->param( 'reverse' ),
@@ -141,7 +139,7 @@
         'subweb'     => scalar $query->param( 'subweb' )
     );
  
-    $session->writeCompletePage($text);
+    $TWiki::SESSION->writeCompletePage($text);
     
 }
 
Index: TWiki/UI/Changes.pm
===================================================================
--- TWiki/UI/Changes.pm	(revision 13172)
+++ TWiki/UI/Changes.pm	(working copy)
@@ -38,21 +38,19 @@
 
 # Command handler for changes command
 sub changes {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
+    TWiki::UI::checkWebExists( $webName, $topic, 'find changes in' );
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'find changes in' );
+    my $skin = $TWiki::SESSION->getSkin();
 
-    my $skin = $session->getSkin();
+    my $text = $TWiki::TEMPLATES->readTemplate( 'changes', $skin );
 
-    my $text = $session->{templates}->readTemplate( 'changes', $skin );
-
     my( $page, $eachChange, $after) = split( /%REPEAT%/, $text );
 
-    my $changeData = $session->{store}->readMetaData( $webName, 'changes' );
+    my $changeData = $TWiki::STORE->readMetaData( $webName, 'changes' );
     my @changes = split( /\r?\n/, $changeData );
     unless( $query->param( 'minor' )) {
         @changes = grep { !/\tminor$/ } @changes;
@@ -67,14 +65,14 @@
     foreach my $change ( reverse @changes ) {
         my( $changedTopic, $login, $time, $rev ) = split( /\t/, $change );
         unless( $done{$changedTopic} ) {
-            next unless $session->{store}->topicExists( $webName, $changedTopic );
+            next unless $TWiki::STORE->topicExists( $webName, $changedTopic );
 
             try {
-                my $summary = $session->{renderer}->summariseChanges(
-                    $session->{user}, $webName, $changedTopic, $rev );
+                my $summary = $TWiki::RENDER->summariseChanges(
+                    $TWiki::SESSION->{user}, $webName, $changedTopic, $rev );
                 my $thisChange = $eachChange;
                 $thisChange =~ s/%TOPICNAME%/$changedTopic/go;
-                my $u = $session->{users}->findUser( $login );
+                my $u = $TWiki::USERS->findUser( $login );
                 my $wikiuser = $u ? $u->webDotWikiName() : '';
                 $thisChange =~ s/%AUTHOR%/$wikiuser/go;
                 $time = TWiki::Time::formatTime( $time );
@@ -85,7 +83,7 @@
                 }
                 $thisChange =~ s/%TIME%/$time/g;
                 $thisChange =~ s/%REVISION%/$srev/go;
-                $thisChange = $session->{renderer}->getRenderedVersion
+                $thisChange = $TWiki::RENDER->getRenderedVersion
                   ( $thisChange, $webName, $changedTopic );
                 $thisChange =~ s/%TEXTHEAD%/$summary/go;
                 $page .= $thisChange;
@@ -97,14 +95,14 @@
     }
     if( $TWiki::cfg{Log}{changes} ) {
         # write log entry
-        $session->writeLog( 'changes', $webName, '' );
+        $TWiki::SESSION->writeLog( 'changes', $webName, '' );
     }
     $page .= $after;
 
-    $page = $session->handleCommonTags( $page, $webName, $topic );
-    $page = $session->{renderer}->getRenderedVersion($page, $webName, $topic );
+    $page = $TWiki::SESSION->handleCommonTags( $page, $webName, $topic );
+    $page = $TWiki::RENDER->getRenderedVersion($page, $webName, $topic );
 
-    $session->writeCompletePage( $page );
+    $TWiki::SESSION->writeCompletePage( $page );
 }
 
 1;
